<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="800">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="80px"
    >
      <el-form-item label="地图名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入地图名称" />
      </el-form-item>
      <el-form-item label="地图图片" prop="imageUrl">
        <UploadImg
          :limit="1"
          v-model="formData.imageUrl"
          :fileSize="5"
        />
      </el-form-item>
      <el-form-item label="图片宽度" prop="width">
        <el-input v-model="formData.width" placeholder="请输入图片宽度" />
      </el-form-item>
      <el-form-item label="图片高度" prop="height">
        <el-input v-model="formData.height" placeholder="请输入图片高度" />
      </el-form-item>
      <el-form-item label="横坐标" prop="x">
        <el-input v-model="formData.x" placeholder="请输入横坐标" />
      </el-form-item>
      <el-form-item label="纵坐标" prop="y">
        <el-input v-model="formData.y" placeholder="请输入纵坐标" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import * as MapConfigApi from '@/api/basic/mapconfig'



defineOptions({ name: 'SystemMapForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: '',
  imageUrl: '',
  width: undefined,
  height: undefined,
  x: undefined,
  y: undefined
})
const formRules = reactive({
  name: [{ required: true, message: '地图名称不能为空', trigger: 'blur' }],
  imageUrl: [{ required: true, message: '地图图片不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await MapConfigApi.selectIsMapById(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await MapConfigApi.insertIsMap(data)
      message.success(t('common.createSuccess'))
    } else {
      await MapConfigApi.updateIsMap(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: '',
    imageUrl: '',
    width: undefined,
    height: undefined,
    x: undefined,
    y: undefined
  }
  formRef.value?.resetFields()
}


</script>
